;***************************************************************************;
;*    Vzor residentnho programu se samozavdnm do horn pamti          *;
;*                     Public Domain by vit$oft                            *;
;***************************************************************************;
;
; Tento komentovan program v jazyku Netwide Assembler (verze 0.98) je uren
; jako vzor pro zatenky v programovn residentnch program v DOSu.
; Ulote tento text pod nzvem TSRUP.ASM a pelote pkazem
;
;   NASMW TSRUP.ASM -f bin -o TSRUP.COM
;
; Peloen program lze spoutt v DOSu nebo v konsoli Windows 9x/NT.
;
; Terminate  and  Stay  Resident  (TSR)  je  tda 16bitovch program, kter
; poskytuj  sluby jinm  souasn bcm  DOSovm programm,  podobn jako
; ovladae  zazen (DEVICE),  kter se  instaluj pi  zavdn systmu. Na
; rozdl od DEVICE, sprvn napsan TSR program lze nainstalovat a v ppad
; poteby a zase odstranit z pamti, pokud ji nen zapoteb.
;
; Pro  pochopen, jak  se TSR  instaluj do  pamti, je  teba znt  principy
; alokace  pamti v  DOSu. MS-DOS   pidluje operan  pam v  16 bajtovch
; kvantech  zvanch 'paragraf'.  Kadmu pidlenmu  pamovmu bloku  tsn
; pedchz paragraf  zvan 'dic blok pamti'  (Memory Control Block, MCB)
; udrujc  informace o  jeho velikosti,  procesu, ktermu  pat a vazb na
; dal  takov bloky.  Pokud program  pod o  pidlen (alokaci) uritho
; mnostv  pamti,  DOS  mus  perovnat  etzec  pamovch  blok, vybere
; souvislou st  pamti o poadovan  velikosti a ozna  ji jako obsazenou.
; Pi spoutn  COM programu z povelov  dky se o alokaci  star pkazov
; interpreter (obvykle COMMAND.COM), kter alokuje dva pamov bloky:
; 1. mal blok pro kopii systmovch promnnch (environment)
; 2. hlavn blok  pro Program Segment Prefix (PSP)  a vlastn kd spoutnho
; programu. Ve  prospch spoutnho programu  je alokovn cel  voln zbytek
; konvenn pamti.
; Po  ukonen bhu  programu DOS   uvoln oba  pamov bloky  alokovan pi
; startu  i  ppadn  dal,   pokud  byly  pidleny  ukonovanmu  procesu
; v prbhu jeho innosti. Residentn programy vyaduj, aby st jejich kdu
; zstala  v  pamti  i  po  ukonen  jejich  bhu.  TSR proto kon volnm
; speciln  funkce  DOSu  31h,  pi  kterm  ur,  kolik  pamti  m zstat
; alokovno. O  toto mnostv pak  bude snena velikost  pamti dostupn pro
; pozdji  spoutn  programy.  Velikost  disponsibiln  pamti  lze zjistit
; pkazem MEM.
;
; Konvenn  pam v  DOSu je  vzcn statek,  vechny ovladae  a residentn
; programy  by mly  bt optimalizovny  na co  nejmen spotebu  residentn
; pamti. Tento  vzorov pi instalaci  do pamti zrove  posouv residentn
; kd tak, aby pekrval nepotebnou st  PSP, dky tomu zabr po instalaci
; pouze 128 bajt.
;
;
; Nejprve definujme nkolik uitench maker.
%MACRO PROC 1      ; Makra PROC a ENDP pouze ohraniuj proceduru.
%1:                ; Jmno procedury bude urovat nvt.
  %PUSH %1         ; Uloen kontextu prostoru jmen.
%ENDMACRO

%MACRO ENDP 1      ; Makra PROC/ENDP lze vynechat, ale zpehleduj
  %IFCTX %1        ; program a kontroluj vnoovn procedur,
    %POP           ; podobn jako pseudoinstrukce %MACRO a %ENDMACRO.
  %ELSE
    %ERROR Unmatched PROC/ENDP %1
  %ENDIF
%ENDMACRO

%MACRO DosFn 1-2   ; Voln sluby DOSu INT 21h AH=%1 BX=%2.
       %IF %1 < 256
         MOV AH,%1
       %ELSE
         MOV AX,%1
       %ENDIF
       %IF %0 = 2 ; Je-li deklarovn druh parametr, vlo se do BX
         MOV BX,%2
       %ENDIF
       INT 21h
%ENDMACRO

%MACRO Write 1+ ; Vypsn textovho etzce na standardn vstup (konsolu).
[SECTION .data]
 %%String: DB %1 ; Literl je deklarovn v sekci '.data' umstn za '.text'.
 %%EndString:
__SECT__
      MOV DX,%%String
      MOV CX,%%EndString-%%String
      CALL Write#Proc
      %IFNDEF Write# ; Volan procedura Write#Proc bude vloena do kdu
        %DEFINE Write# ; pouze pi prvnm pouit makra.
        JMP SHORT Write#Endp
        Write#Proc:  ; CX bajt etzce DX^
         DosFn 40h,1 ; bude zapsno do handle StdOut=1.
         RET
        Write#Endp:
      %ENDIF
%ENDMACRO ; Write

%MACRO AbortIf 2+  ; %1=podmnka  %2=chybov zprva
       J%-1 %%Continue ; Pokrauj, nen-li podmnka %1 splnna,
       Write %2    ; jinak vypi chybovou zprvu %2+
       DosFn 4C08h ; a havarijn ukoni program s errorlevel 8.
%%Continue:
%ENDMACRO ; AbortIf

     ORG 100h ; COM program zan na ofsetu 256, CS=DS=ES=SS ukazuj na PSP.
     SECTION .text
     JMP SHORT Main

ShiftedResidentOrg EQU 5Ch ; Od tto adresy PSP jej lze pepsat.
ResidentOrg:       EQU $   ; Bude pi instalaci posunut dozadu na ofset 5Ch.
Shift              EQU (ResidentOrg-ShiftedResidentOrg)

PROC NewInt08 ; Nov obsluha peruen realizuje vlastn funkci residentu.
; FAR  JUMP   na  jejm  konci   etz  tuto  rutinu   do  ppadnch  dve
; instalovanch  obslunch  rutin  a  nakonec  na  pvodn obsluhu peruen
; v BIOSu, kter se postar o potvrzen  peruen v adii 8259 a o ukonen
; instrukc IRET.
; Peruen Int08  vznik hardwarov z asovae  kadch 55 ms. Na  vstupu do
; obslun  rutiny  nejsou  znmy  hodnoty  jinch  registr ne CS:IP. Kad
; pstup k  datm proto mus  bt vztaen k  segmentovmu registru CS,  a ne
; k defaultu DS. Jeliko to prodluuje  kadou instrukci pistupujc k datm
; o   jeden bajt  prefixu, me bt  pi tyech a  vce takovch instrukcch
; vhodnj doasn uschovat obsah DS a naplnit jej hodnotou z CS.
;
; elem  tohoto  vzorovho  TSR  je  udrovat  NumLock klvesnice v zapnutm
; stavu. Sprvnou funkci residentu lze snadno ovit, pokud zkusme nco pst
; na numerick klvesnici s vypnutm NumLock.  V DOSu nebo ve Windows 9x (ale
; ne v NT) bude indiktor NumLock neustle BIOSem rozsvcovn.
; Nen to tedy nijak zvl uiten  program, ale me poslouit jako kostra
; pro sloitj residentn programy.
     PUSH AX
      PUSH DS
       SUB AX,AX
       MOV DS,AX   ; Na segmentu DS=0 budeme mnit stav klvesnice.
       OR BYTE [417h],20h ; Nastaven stavovho bitu NumLock na 'zapnuto'.
      POP  DS      ; Ped ukonenm obslun rutiny musej bt vechny
     POP AX        ; registry vrceny do pvodnho stavu.
     JMP 0:0       ; Immediate segment:ofset v tle tto instrukce bude
  OldInt08 EQU $-4 ; pojmenovn OldInt08 a pozdji pepsn aktulnm
ENDP NewInt08      ; vektorem petenm z tabulky vektor peruen.

Identificator        DB 'TSRUP' ; Uniktn nzev identifikujc program.
TsrStatus            DB 0   ; Tento bajt dopluje Indentificator, aby se
%DEFINE Passive      BYTE 0 ; odliil aktivn a pasivn (nenainstalovan)
%DEFINE Active       BYTE 1 ; stav residentn instance.
SizeOfIdentificator  EQU $-Identificator
SizeOfResident       EQU $-Shift
ResidentParagraphs   EQU (SizeOfResident+15) >> 4

ShiftedNewInt08      EQU NewInt08-Shift
ShiftedOldInt08      EQU OldInt08-Shift
ShiftedIdentificator EQU Identificator-Shift
ShiftedTsrStatus     EQU TsrStatus-Shift

PROC Main ; dic procedura zahajuje residentn (od)instalaci a vypisuje
     ; zprvy o innosti na systmov vstup, tj.na obrazovku.
     Write 'TSRUP skeleton',13,10 ; Nejprve se pedstav nzev programu.
     CALL Init  ; Zjiuje zadan parametry, pak posune resident do PSP.
     CMP AL,'u' ; Poadavek na odinstalaci /u ?
     JNE .30
     CALL InstallationCheck
     AbortIf Z, 'was not installed yet.',13,10
     CALL Uninstall
     AbortIf C, 'cannot uninstall - another TSR was hooked later.',13,10
     Write 'was uninstalled.',13,10
     DosFn 4C00h ; Ukonen programu.

.30: CMP AL,'j' ; Poadavek na instalaci do konvenn pamti /j ?
     JNE .70
     CALL InstallationCheck
.50: AbortIf NZ, 'is installed already.',13,10
.60: Write 'was installed in conventional memory.',13,10
     JMP InstallConventional

.70: CMP AL,'i'   ; Poadavek na instalaci do horn pamti /i ?
     AbortIf NE,'Options: /InstallToUpper /J:InstallConv /Uninstall',13,10
     CALL InstallationCheck
     JNZ .50      ; Skok na chybov hlen, pokud ji byl instalovn.
     CALL FindUMB ; Pokus o alokaci bloku horn pamti.
     JC .60       ; Skok, nen-li horn pam dostupn.
     Write 'was installed in upper memory.',13,10
     JMP InstallUpper
ENDP Main

PROC Init ; Probere parametry pkazov dky a pak posune resident do PSP.
     MOV SI,128+1 ; Na tomto ofsetu v PSP zanaj parametry.
     CLD
.10: LODSB
     CMP AL,'/'
     JE .30
     CMP AL,'-'    ; Parametr me bt uvozen znakem '/' nebo '-'.
     JE .30
     CMP AL,13     ; Toto je pznak konce parametr.
     JNE .10       ; Pokrauj ve vyhledvn uvozujcho prefixu.
     JE  .40       ; Jsme na konci pkazovho dku, AL=13.
.30: LODSB         ; Naten psmene za prefixem '/' nebo '-'.
     OR AL,'A'^'a' ; Pevod na mal psmeno
.40: PUSH AX       ; a pechodn uloen.
; Pkazov dka je zkontrolovna, PSP nebude nadle zapoteb.
; Nyn program dealokuje environment pro ppad, e se bude instalovat.
      MOV ES,[2Ch] ; Adresa promnnch procesu (environment) jde do ES
      DosFn 49h    ; a tento blok bude dealokovn.
      DosFn 3508h  ; Peten vektoru (ukazatele na obsluhu) peruen 08
      MOV WORD [OldInt08+0],BX ; a jeho uloen do tla budoucho residentu.
      MOV WORD [OldInt08+2],ES
      PUSH DS      ; Nyn provedeme posun residentn sti do PSP.
      POP ES       ; DS i ES adresuj segment PSP.
      MOV SI,ResidentOrg
      MOV DI,ShiftedResidentOrg
      MOV CX,SizeOfResident
      CLD ; Residentn st se posune na ni adresu a pekryje tak
      REP MOVSB    ; st PSP, kter ji nen zapoteb.
     POP AX
     RET ; Procedura vrac v AL='i','j','u' nebo 13.
ENDP Init

PROC InstallConventional       ; Klasick residentn ukonen programu.
     MOV [ShiftedTsrStatus],Active ; Identifiktor se ozna jako aktivn.
     MOV DX,ShiftedNewInt08    ; Vektor peruen 08 se nastav na novou
     DosFn 2508h               ; obslunou rutinu.
     MOV DX,ResidentParagraphs ; Mnostv residentn pamti.
     DosFn 3100h               ; Residentn ukonen programu.
ENDP InstallConventional

; Od verze  5 piel MS-DOS s  konceptem vyuit pamti nad konvenn hranic
; 9000:FFFF, takzvanou  horn (upper) pamt. Jej  zpstupnn vyaduje dva
; ovladae: HIMEM a EMM386. Residentn  programy mohou bt nahrvny do horn
; pamti  internm povelem  LOADHIGH, ale  je zde  problm. Horn  pam bv
; fragmentovan a zaveden TSR vyaduje alokaci bloku horn pamti dostaten
; velkho  pro  cel  program,  nejen  pro  jeho  residentn  st.  Proto by
; residentn programy  nemly spolhat na  LOADHIGH, pop. MEMORY  MAKER, ale
; msto toho se spustit konvennm  zpsobem a alokovat horn pam vlastnmi
; silami. Takov  residentn program se  pak me spokojit  s nalezenm pouze
; tak  velkho  bloku  horn  pamti,  kter  sta  pro  jeho  pomrn malou
; residentn st.

PROC InstallUpper ; Instalace do bloku horn pamti adresovanho
     SUB SI,SI    ; segmentem ES, kter ji byl dve alokovn ve FindUMB.
     SUB DI,DI
     CLD
     MOV CX,SizeOfResident            ; Zatek PSP a pilehl residentn
     REP MOVSB                        ; blok bude zkoprovn do horn pamti
     MOV [ES:ShiftedTsrStatus],Active ; a pak oznaen jako aktivn.
     PUSH DS
      PUSH ES
      POP DS      ; DS je doasn nastaven na segment horn pamti.
      MOV DX,ShiftedNewInt08
      DosFn 2508h ; Vektor peruen 08 bude ukazovat do horn pamti.
     POP DS
     MOV AX,ES
     MOV BX,AX    ; Segment horn pamti se uschov do BX.
     DEC AX       ; O jeden paragraf ne je MCB.
     MOV ES,AX    ; MCB segment naeho pamovho bloku.
     MOV DI,8     ; Na tomto ofsetu v MCB by mlo bt jmno vlastnka,
     MOV SI,Identificator  ; zobrazovan nap. pkazem MEM /C.
     %IF SizeOfIdentificator < 8
      MOV CL,SizeOfIdentificator
     %ELSE
      MOV CL,8    ; Dlka jmna vlastnka bloku nesm pekroit 8.
     %ENDIF
     REP MOVSB    ; Jmno residentnho bloku je nyn nastaveno.
     DosFn 50h    ; Aktuln PSP se zmn na segment horn pamti v BX.
     PUSH DS
     POP ES       ; ES ukazuje opt na bc PSP v konvenn pamti
     DosFn 49h    ; a cel tento program se nyn dealokuje.
     ; Nsledujc instrukce ji pob v prv dealokovan pamti,
     ; natst ji DOS dosud nemohl pidlit niemu jinmu a tak ve funguje.
     MOV DX,ResidentParagraphs
     DosFn 3100h  ; Residentn ukonen ponech horn blok.
ENDP InstallUpper

PROC Uninstall    ; Obnovuje pvodn vektory peruen, dealokuje residentn
     PUSH DS      ; pam adresovanou registrem ES (horn nebo konvenn).
       SUB AX,AX
       MOV DS,AX  ; Tabulka vektor peruen je na segmentu 0.
       MOV AX,ES  ; Segment odinstalovvan instance by ml
       CMP  AX,[WORD (4*08h+2)] ; souhlasit s dajem v tabulce pro INT08.
     POP DS
     STC          ; Nvrat s pznakem chyby CF, pokud vektory nesouhlas.
     JNE .90      ; V takovm ppad deinstalace nen mon.
     PUSH DS      ; Jinak se peruen vrt k pvodnmu vektoru
       LDS DX,[ES:ShiftedOldInt08] ; z doby ped instalac.
       DosFn 2508h ; Obnova vektoru peruen.
     POP DS
     MOV [ES:ShiftedTsrStatus],Passive ; InstallationCheck ji kopii nenajde.
     DosFn 49h     ; Dealokace star residentn pamti na segmentu ES.
.90: RET
ENDP Uninstall

; Dobr residentn  program nedovol zbytenou  vcensobnou instalaci ,  co
; vyaduje kontrolu ptomnosti TSR v pamti. Jako metodu detekce ptomnosti
; preferuji vyhledvn podle jmna, co  je nenron na spotebu residentn
; pamti (residentn se ukld pouze identifikan jmno). Instalovan bc
; resident  mus  bt  odlien  od   pasivnho  stavu,  aby  nebyla  kontrola
; ptomnosti zmatena ppadnm nlezem stejnho identifiktoru v nesmazanch
; pamovch blocch nebo ve vyrovnvac pamti.

PROC InstallationCheck ; Zjiuje ptomnost dve instalovan instance TSR.
; Identifiktor tto  instance bude doasn oznaen  jako aktivn a procedura
; pak vyhled stejn identifiktor na vech monch segmentech.
     MOV [ShiftedTsrStatus],Active
     MOV DX,ShiftedIdentificator ; Ofset identifiktoru v tto instanci.
     MOV BX,SizeOfIdentificator
     CLD
     SUB AX,AX ; Tento registr si pamatuje prv prohldvan segment.
.40: DEC AX    ; Budou se provovat vechny od FFFF a po 0000.
     JZ .90    ; Skok, pokud ji jsme na segmentu 0 a shoda nenalezena.
     MOV ES,AX
     MOV DI,DX
     MOV SI,DX
     MOV CX,BX ; Dlka identifiktoru vetn modifiktoru TsrStatus.
     REPE CMPSB
     JNE .40
     MOV CX,DS ; Identifiktor byl nalezen, ale
     CMP CX,AX ; shoda se sebou samm se nepot.
     JE .40    ; V tom ppad  prohledvn pokrauje pod akt.segmentem.
.90: MOV [ShiftedTsrStatus],Passive; Na konci se vrt stav identifiktoru.
     RET       ; ZF=1 pokud jet nebyl instalovn, jinak ZF=0 a ES=segment.
ENDP InstallationCheck

; Horn pam v MS-DOS nebude dostupn bez dvou ovlada zavedench
; v CONFIG.SYS:
;   DEVICE=HIMEM.SYS
;   DEVICE=EMM386.EXE RAM  a/nebo NOEMS
; Ale  ani s  touto konfigurac  jet nebude  pi vyvoln  funkice DOSu 48h
; horn pam  automaticky alokovna. Systm  je teba doasn  nastavit tak,
; aby zaleoval horn  pamov bloky do etzu volnch  MCB (Link Status) a
; podobn je  teba pozmnit alokan  strategii, kter implicitn  preferuje
; pouze konvenn pam.

PROC FindUMB     ; Procedura se pokus alokovat ResidentParagraphs horn
                 ; pamti a jej segment d do ES. CF nastaven pi nespchu.
     DosFn 5800h ; Naten strategie pidlovn pamti.
     JC .90      ; Chyba vznikne v DOSu verze < 3.
     MOV SI,AX   ; seln hodnota strategie se doasn uschov v SI.
     DosFn 5802h ; Naten stavu etzen konvenn a horn pamti.
     JC .90      ; Sele v DOSu verze < 5.
     MOV DX,AX   ; Stav etzen se ulo do DL.
     DosFn 5803h,1 ; Nastav nov stav na  1=vetn horn pamti.
     DosFn 5801h,41h  ; Nastav strategii na 41h=horn, nejlep vyuit.
     DosFn 48h,ResidentParagraphs ; Pokus o alokaci pamovho bloku.
     PUSHF       ; Vsledek alokace (CF=chyba) se doasn ulo.
      MOV ES,AX  ; Segmentov adresa horn pamti, pokud byla pidlena.
      SUB BX,BX  ; Bez ohledu na vsledek je teba obnovit pvodn stav.
      MOV BL,DL  ; Stav etzen byl uchovn v DL.
      DosFn 5803h; Obnova stavu etzen.
      DosFn 5801h,SI ; Obnova alokan strategie z registru SI.
     POPF        ; Vrac v ES alokovan segment, platn pokus m CF=0.
.90: RET
ENDP FindUMB

; Tento program TSRUP ve zdrojovm i peloenm tvaru lze najt na
; strnkch vit$oft freeware http://freeweb.bohemia.net/vitSoft
;
; Pro kompilaci je nutn freewarov Netwide Assembler
; www.web-sites.co.uk/nasm/ver.html
;
; Dal odkazy k programovn viz x86 Assembler WebRing
; www.webring.org/cgi-bin/webring?ring=x86asm&list
;
; internetov magazn Assembly Programming Journal
; http://asmjournal.freeservers.com/

; referenn zdroj informac o peruench Interrupt List
; www.cs.cmu.edu/afs/cs.cmu.edu/user/ralf/pub/WWW/files.html

END
